commit f4aa5a3e95ba106f3149157a0278616f7a5fd192
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Feb 1 21:36:42 2022

    Fortran: error recovery when simplifying EOSHIFT
    
    gcc/fortran/ChangeLog:
    
            PR fortran/104331
            * simplify.c (gfc_simplify_eoshift): Avoid NULL pointer
            dereference when shape is not set.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/104331
            * gfortran.dg/eoshift_9.f90: New test.
    
    (cherry picked from commit 447047a8f95c6bf4b1873f390c833e91aa8af18c)

diff --git a/gcc/fortran/simplify.c b/gcc/fortran/simplify.c
index 4c9dccb90e3..3599e1b3194 100644
--- a/gcc/fortran/simplify.c
+++ b/gcc/fortran/simplify.c
@@ -2572,6 +2572,9 @@ gfc_simplify_eoshift (gfc_expr *array, gfc_expr *shift, gfc_expr *boundary,
   if (arraysize == 0)
     goto final;
 
+  if (array->shape == NULL)
+    goto final;
+
   arrayvec = XCNEWVEC (gfc_expr *, arraysize);
   array_ctor = gfc_constructor_first (array->value.constructor);
   for (i = 0; i < arraysize; i++)
diff --git a/gcc/testsuite/gfortran.dg/eoshift_9.f90 b/gcc/testsuite/gfortran.dg/eoshift_9.f90
new file mode 100644
index 00000000000..f711b04a7da
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/eoshift_9.f90
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/104331 - ICE in gfc_simplify_eoshift
+! Contributed by G.Steinmetz
+
+program p
+  character(3), parameter :: a(:) = ['123'] ! { dg-error "deferred shape" }
+  character(3), parameter :: b(*) = eoshift(a, 1)
+end

